package semaphor;

import java.util.ArrayList;

public class Semaphor{
	
	private ArrayList<MyProcess> waitList;
	private int status;
	private MyProcess activePro;
	private boolean isStarted;
	
	public Semaphor(int status){
		this.status= status;
		waitList= new ArrayList<MyProcess>();
		isStarted = false;
	}
	
	public void addProzess(MyProcess process){
		status--;
		waitList.add(process);
		System.out.println("Process was added, waitlist size is "+waitList.size());
		if(isStarted){
			runNext();
		}
	}
	
	public synchronized void runNext(){
		if(activePro==null){
			activePro=waitList.get(0);
			activePro.run();
		}
	}
	
	public synchronized void isDone(MyProcess iactivePro){
		activePro=null;
		waitList.remove(0);
		status++;
		System.out.println("Waitlist size is "+waitList.size());
		if(!(waitList.size()==0)&&isStarted){
			runNext();
		}
		
	}
	
	public void start(){
		System.out.println("Starting the Semaphor");
		isStarted=true;
		if(status>=0){
			runNext();
		}else{
			//Do nothing, have to wait until active process is done
			//so wait
		}
	}
	
	public void stop(){
		isStarted=false;
	}
}
